/**
  ******************************************************************************
  * @file    Project/PT32x031_StdPeriph_Templates/main.c 
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2020/04/28
  * @brief   Main 
  ******************************************************************************
  * @attention
  *
  * 
  *
  * 
  * 
  * 
  *
  * 
  *
  * 
  * 
  * 
  * 
  * 
  *
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "main.h"

/** @addtogroup PT32x031_StdPeriph_Templates
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
#define SOFT_DELAY Delay(0x0FFFFF);
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/
void LED_GPIO_Config(void)
{		
		/*һGPIO_InitTypeDef͵Ľṹ*/
		GPIO_InitTypeDef GPIO_InitStructure;
		/*ѡҪƵGPIO*/
		GPIO_InitStructure.GPIO_Pin = LED1_GPIO_PIN;	

		/*ģʽΪͨ*/
		GPIO_InitStructure.GPIO_Mode = GPIO_OType_PP;   

		/*ÿ⺯ʼGPIO*/
		GPIO_Init(LED1_GPIO_PORT, &GPIO_InitStructure);	
		
		/*ѡҪƵGPIO*/
		GPIO_InitStructure.GPIO_Pin = LED2_GPIO_PIN;

		/*ÿ⺯ʼGPIO*/
		GPIO_Init(LED2_GPIO_PORT, &GPIO_InitStructure);
		
		/*ѡҪƵGPIO*/
		GPIO_InitStructure.GPIO_Pin = LED3_GPIO_PIN;

		/*ÿ⺯ʼGPIO*/
		GPIO_Init(LED3_GPIO_PORT, &GPIO_InitStructure);

		/* رled	*/
		GPIO_SetBits(LED1_GPIO_PORT, LED1_GPIO_PIN);
		
		/* رled	*/
		GPIO_SetBits(LED2_GPIO_PORT, LED2_GPIO_PIN);	 
    
    /* رled	*/
		GPIO_SetBits(LED3_GPIO_PORT, LED3_GPIO_PIN);
}

void Delay(__IO uint32_t nCount)	 //򵥵ʱ
{
	for(; nCount != 0; nCount--);
}
/**
  * @brief  Main program.
  * @param  None
  * @retval None
  */
int main(void)
{

  /*!< At this stage the microcontroller clock setting is already configured, 
       this is done through SystemInit() function which is called from startup
       file (startup_pt32f0xx.s) before to branch to application main.
       To reconfigure the default setting of SystemInit() function, refer to
       system_pt32f0xx.c file
     */ 
      
  /* Add your application code here
     */
	/* LED ˿ڳʼ */
	LED_GPIO_Config();	 

	while (1)
	{
		/**/
		LED1_ON;			 
		SOFT_DELAY;
		/**/
		LED1_OFF;		  
		/*̵*/
		LED2_ON;			 
		SOFT_DELAY;
		/*̵*/
		LED2_OFF;		  
		/**/
		LED3_ON;			 
		SOFT_DELAY;
		/**/
		LED3_OFF;		   

		/*ʾ  ɫ*/
		LED_RED;
		SOFT_DELAY;
		
		LED_GREEN;
		SOFT_DELAY;
		
		LED_BLUE;
		SOFT_DELAY;
		
		LED_YELLOW;
		SOFT_DELAY;
		
		LED_PURPLE;
		SOFT_DELAY;
				
		LED_CYAN;
		SOFT_DELAY;
		
		LED_WHITE;
		SOFT_DELAY;
		
		LED_RGBOFF;
		SOFT_DELAY;		
	}
}


#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/**
  * @}
  */


/************************ (C) COPYRIGHT PENGPAI Microelectronics *****END OF FILE****/
