/**
  ******************************************************************************
  * @file    Project/PT32x031_StdPeriph_Templates/main.c 
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2020/04/28
  * @brief   Main 
  ******************************************************************************
  * @attention
  *
  * 
  *
  * 
  * 
  * 
  *
  * 
  *
  * 
  * 
  * 
  * 
  * 
  *
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "main.h"

/** @addtogroup PT32x031_StdPeriph_Templates
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/
void LED_GPIO_Config(void)
{		
		/*һGPIO_InitTypeDef͵Ľṹ*/
		GPIO_InitTypeDef GPIO_InitStructure;
		/*ѡҪƵGPIO*/
		GPIO_InitStructure.GPIO_Pin = LED1_GPIO_PIN;	

		/*ģʽΪͨ*/
		GPIO_InitStructure.GPIO_Mode = GPIO_OType_PP;   

		/*ÿ⺯ʼGPIO*/
		GPIO_Init(LED1_GPIO_PORT, &GPIO_InitStructure);	
		
		/*ѡҪƵGPIO*/
		GPIO_InitStructure.GPIO_Pin = LED2_GPIO_PIN;

		/*ÿ⺯ʼGPIO*/
		GPIO_Init(LED2_GPIO_PORT, &GPIO_InitStructure);
		
		/*ѡҪƵGPIO*/
		GPIO_InitStructure.GPIO_Pin = LED3_GPIO_PIN;

		/*ÿ⺯ʼGPIO*/
		GPIO_Init(LED3_GPIO_PORT, &GPIO_InitStructure);

		/* رled	*/
		GPIO_SetBits(LED1_GPIO_PORT, LED1_GPIO_PIN);
		
		/* رled	*/
		GPIO_SetBits(LED2_GPIO_PORT, LED2_GPIO_PIN);	 
    
    /* رled	*/
		GPIO_SetBits(LED3_GPIO_PORT, LED3_GPIO_PIN);
}

 /**
  * @brief  USART GPIO ,
  * @param  
  * @retval 
  */
void UART_Config(void)
{
  UART_InitTypeDef UART_InitStruct;
	/*PB6ΪUART0_TX,PA15ΪUART0_RX*/
  GPIO_PinAFConfig(CMSDK_PB, GPIO_PinSource6, GPIO_AF_3);
  GPIO_PinAFConfig(CMSDK_PA, GPIO_PinSource15, GPIO_AF_3);
	/*ʼUART0*/
  UART_InitStruct.UART_BaudRate = 19200;
  UART_InitStruct.UART_WordLength = UARTM_8D;
  UART_InitStruct.UART_StopBit = UART1StopBit;
  UART_InitStruct.UART_Parity = UART_ODD_PARITY;
  UART_InitStruct.UART_RXEN = ENABLE;
  UART_InitStruct.UART_SampleRate = UART_SAMPLERATEX16;
  UART_Init(UART0, &UART_InitStruct);
	/*UART0շ*/		
  UART_Cmd(UART0, ENABLE);
}

/**
  * @brief  ӡָʾϢ
  * @param  
  * @retval 
  */
static void Show_Message(void)
{
	UART_InitTypeDef  UART_InitStruct;
  printf("\r\nһָͨͨRGBʵʵ\r\n");
  printf("\r\nʹUARTΪ%d 8-N-1 \r\n",19200);
  printf("\r\nӵָRGBʵɫָӦ£\r\n");
  printf("\r\n   ָ   ------ ʵɫ \r\n");
  printf("\r\n     1    ------     \r\n");
  printf("\r\n     2    ------     \r\n");
  printf("\r\n     3    ------     \r\n");
  printf("\r\n     4    ------     \r\n");
  printf("\r\n     5    ------     \r\n");
  printf("\r\n     6    ------     \r\n");
  printf("\r\n     7    ------     \r\n");
  printf("\r\n     8    ------     \r\n");  
}

 /**
  * @brief   IOΪEXTIжϿڣжȼ
  * @param  
  * @retval 
  */
void TIMER4_Config(void)
{
  TIM_TimeBaseInitTypeDef TimeBaseInit;
  NVIC_InitTypeDef NVIC_InitStruct;
  NVIC_InitStruct.NVIC_IRQChannel = TIMER4_IRQn;
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x00;
	NVIC_Init(&NVIC_InitStruct);
  /*öʱƥֵ,Ϊ0.5S*/
	TimeBaseInit.MatchValue = 128*3;
  /*öʱʱӷƵϵΪ10us*/	
	TimeBaseInit.Prescaler = 0xFF;
  /*öʱģʽΪ*/
  TimeBaseInit.CounterMode = TIM_CNT_MODE_UP;	
  /*ʼTIMER4*/	
	TIM_TimeBaseInit(TIM4, &TimeBaseInit);
  /*ʹTIMER4ж*/	
	TIM_ITConfig(TIM4, TIM_INT_MR0, ENABLE);		
}

 /**
  * @brief  ʱ
  * @param  
  * @retval 
  */
static void Delay(__IO uint32_t nCount)	 
{
	for(; nCount != 0; nCount--);
}

/**
  * @brief  Main program.
  * @param  None
  * @retval None
  */
int main(void)
{

  /*!< At this stage the microcontroller clock setting is already configured, 
       this is done through SystemInit() function which is called from startup
       file (startup_pt32f0xx.s) before to branch to application main.
       To reconfigure the default setting of SystemInit() function, refer to
       system_pt32f0xx.c file
     */ 
      
  /* Add your application code here
     */
	uint8_t clkbak;
  /* ʼRGBʵ */
  LED_GPIO_Config();
	/*ʼTIMER4*/
	TIMER4_Config();
	/*ʼUART0*/
  UART_Config();		
	printf("\r\n ӭʹ΢  PT32F0XX  塣\r\n");
  printf("\r\n PT32F0XX ˯ģʽ\r\n");
	
	printf("\r\n ˵\r\n");
	printf("\r\n 1.Ʊʾ˯״̬Ʊʾմ˯״̬\r\n");
	printf("\r\n 2.ʹ WFE ¼ѷʽͨ¼ѲҪʹNVICж\r\n");
	printf("\r\n 3.̼ؽMCUҪſԽ뵽Deepsleep\r\n");
	printf("\r\n 4.һʱԶ˯״̬˯״̬£ʹUSERKEY\r\n");
	printf("\r\n 5.ִһѭ\r\n");
	printf("\r\n ̵()->(˯ģʽ)->TIMER4ʱ->(ձ)\r\n");
	printf("\r\n 6.˯״̬£ҲֱͨSWDӿڣȥѽ̵Debug\r\n");
  /* Infinite loop */
  while (1)
  {
		printf("\r\n PT32F0XXУ̵\r\n");	
		LED_GREEN;	
		Delay(0x3FFFFF);
		printf("\r\n ģʽȴTIMER4\r\n");
    /* ͨŽӿշݣôҪȷFIFOȫɺٽߣȻ׵ݶʧ */		
		Delay(0x1F00);
    /* ַָRGBʵɫ */
		/*ʹúָʾ˯״̬*/
		LED_RED;
		/*˯ģʽ*/
		TIM_Cmd(TIM4, ENABLE);
		clkbak=CMSDK_SYSCON->SYSCLK;
		PWR_EnterSTANDBYMode(PWR_STANDBYEntry_WFE);
		CMSDK_SYSCON->SYSCLK&=~0x000000FF;
		CMSDK_SYSCON->SYSCLK|=clkbak;
		/*ȴжϻ  USERKEYж*/
		LED_BLUE;
		/*ѣָʾ*/
		printf("\r\n ˳˯ģʽ\r\n");
		Delay(0x3FFFFF);					

   } 		 
 
}


#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/**
  * @}
  */


/************************ (C) COPYRIGHT PENGPAI Microelectronics *****END OF FILE****/
