/**
  ******************************************************************************
  * @file    Project/PT32x031_StdPeriph_Templates/main.c 
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2020/04/28
  * @brief   Main 
  ******************************************************************************
  * @attention
  *
  * 
  *
  * 
  * 
  * 
  *
  * 
  *
  * 
  * 
  * 
  * 
  * 
  *
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "main.h"

/** @addtogroup PT32x031_StdPeriph_Templates
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
#define UserKey_GPIO_Port                CMSDK_PA
#define UserKey_Pin                      GPIO_Pin_11

#define PWM0_CH1_GPIO_Port               CMSDK_PB
#define PWM0_CH1_PinSource               GPIO_PinSource4
#define PWM0_CH1_Pin                     GPIO_Pin_4

	/*************е***************/	
	/***********************************************
	#pythonű	count.py
	#PWM
	POINT_NUM = 110

	#ڱ
	PERIOD_CLASS = 10

	#ʱʱ
	TIMER_TIM_Period = 2**10
	#ʱƵ
	TIMER_TIM_Prescaler = 67

	#PT32ϵͳʱƵʺ
	f_pclk = 24000000
	t_pclk = 1/f_pclk

	#ʱupdate¼
	t_timer = t_pclk*TIMER_TIM_Prescaler*TIMER_TIM_Period

	#ÿPWMʱ
	T_Point = t_timer * PERIOD_CLASS

	#
	T_Up_Down_Cycle = T_Point * POINT_NUM

	print ("ڣ",T_Up_Down_Cycle)
	
	#н
	
	ڣ3.12888
	************************************************************/
/*PWM źŵƵ F = TIM_CLK/{(MR0+1)*(PSC+1)}*/
#define            ADVANCE_TIM_PERIOD            (1024-1)
#define            ADVANCE_TIM_PSC               (67-1)
#define            ADVANCE_TIM_PULSE             (1-1)
#define            ADVANCE_TIM_DeadTime           0

/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/
void LED_GPIO_Config(void)
{		
		/*һGPIO_InitTypeDef͵Ľṹ*/
		GPIO_InitTypeDef GPIO_InitStructure;
		/*ѡҪƵGPIO*/
		GPIO_InitStructure.GPIO_Pin = LED1_GPIO_PIN;
		/*ûմ*/
    GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
		/*ģʽΪͨ*/
		GPIO_InitStructure.GPIO_Mode = GPIO_OType_PP;   

		/*ÿ⺯ʼGPIO*/
		GPIO_Init(LED1_GPIO_PORT, &GPIO_InitStructure);	
		
		/*ѡҪƵGPIO*/
		GPIO_InitStructure.GPIO_Pin = LED2_GPIO_PIN;

		/*ÿ⺯ʼGPIO*/
		GPIO_Init(LED2_GPIO_PORT, &GPIO_InitStructure);
		
		/*ѡҪƵGPIO*/
		GPIO_InitStructure.GPIO_Pin = LED3_GPIO_PIN;

		/*ÿ⺯ʼGPIO*/
		GPIO_Init(LED3_GPIO_PORT, &GPIO_InitStructure);

		/* رled	*/
		GPIO_SetBits(LED1_GPIO_PORT, LED1_GPIO_PIN);
		
		/* رled	*/
		GPIO_SetBits(LED2_GPIO_PORT, LED2_GPIO_PIN);	 
    
    /* رled	*/
		GPIO_SetBits(LED3_GPIO_PORT, LED3_GPIO_PIN);
}
 /**
  * @brief  UART GPIO ,
  * @param  
  * @retval 
  */
void UART_Config(void)
{
  UART_InitTypeDef UART_InitStruct;
	/*PB6ΪUART0_TX,PA15ΪUART0_RX*/
  GPIO_PinAFConfig(CMSDK_PB, GPIO_PinSource6, GPIO_AF_3);
  GPIO_PinAFConfig(CMSDK_PA, GPIO_PinSource15, GPIO_AF_3);
	/*ʼUART0*/
  UART_InitStruct.UART_BaudRate = 19200;
  UART_InitStruct.UART_WordLength = UARTM_8D;
  UART_InitStruct.UART_StopBit = UART1StopBit;
  UART_InitStruct.UART_Parity = UART_ODD_PARITY;
  UART_InitStruct.UART_RXEN = ENABLE;
  UART_InitStruct.UART_SampleRate = UART_SAMPLERATEX16;
  UART_Init(UART0, &UART_InitStruct);
	/*UART0շ*/		
  UART_Cmd(UART0, ENABLE);
}
 
/**
  * @brief  ʼû
  * @param  None
  * @retval None
  */
static void UserKey_GPIO_Config(void)
{

  GPIO_InitTypeDef  GPIO_InitStruct;	
	/*ѡðΪ*/
  GPIO_InitStruct.GPIO_Mode = GPIO_Mode_IN;
	GPIO_InitStruct.GPIO_PuPd = GPIO_PuPd_NOPULL;
	/*ѡ񰴼*/
	GPIO_InitStruct.GPIO_Pin = UserKey_Pin;
	/*ʹýṹʼ*/
	GPIO_Init(UserKey_GPIO_Port, &GPIO_InitStruct);
}

/**
  * @brief  ʼPWMܽ
  * @param  None
  * @retval None
  */
static void PWM_GPIO_Config(void)
{	
  /* PB4ΪPWM */	
  GPIO_PinAFConfig(PWM0_CH1_GPIO_Port, PWM0_CH1_PinSource, GPIO_AF_0);
}


/**
  ******************************************************************************
  * @note PWMź ںռձȵļ
  * MR0 ƥĴھPWM
  * MRx ռձƥĴھÿ·PWMռձ(x=1,2,3,4)
  * CLK_CNT : ʱӣFcksys/(psc+1) = 24M/(psc+1)
  * PWMźŵڣ T = (MR0+1) * (1/CLK_cnt) = (MR0+1)*(PSC+1) / 24M
  * PWMźŵռձȣP = (MRx+1) / (MR0+1)
  ******************************************************************************
  */
/**
  * @brief  PWMģʽ
  * @param  None
  * @retval None
  */
static void PWM_Mode_Config(void)
{
  PWM_TimeBaseInitTypeDef  TimeBaseInit;
	PWM_OutputInitTypeDef OutInit;
	NVIC_InitTypeDef NVIC_InitStruct;
  /*ʹTIMER0NVIC*/
  NVIC_InitStruct.NVIC_IRQChannel = TIMER0_IRQn;
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x00;
	NVIC_Init(&NVIC_InitStruct);
	/*ƥĴ,ۼMR0+1Ƶʺһ»ж*/
	TimeBaseInit.CounterReload = ADVANCE_TIM_PERIOD;
	/* CNTʱ = Fcksys/(psc+1)*/
	TimeBaseInit.Prescaler = ADVANCE_TIM_PSC;
	/*ģʽΪϼ*/
	TimeBaseInit.CounterMode = PWM_CNT_MODE_UP;
	/*رսģʽ*/
	TimeBaseInit.CounterDirRv_EN = PWM_CounterDirRv_DIS;
	/*ʼʱ*/
  PMW_TimeBaseInit(PWM0, &TimeBaseInit);
  /* ΪPWMͨΪ2ͨ*/
	OutInit.Channel =PWM_CH_1;
  /* ΪPWMģʽTCֵռձƥĴֵߵƽ*/	
	OutInit.OutputMode = COMPAER_MODE2;
	 /* ûʹ*/
  OutInit.ControlN = PWM_CHNCTL_DISABLE;
	/* ʱ*/
	OutInit.DeathTime = ADVANCE_TIM_DeadTime;
	/* PWMʱƽ״̬ɲʱԼPWMδʹ֮ǰƽ״̬ɲ󻥲ͨƽȻ*/	
	OutInit.IdleState = PWM_IDLE_LOW;
  /* PWMռձ P = (ADVANCE_TIM_PULSE+1) / (ADVANCE_TIM_PERIOD+1)*/	
	OutInit.CompareValue = ADVANCE_TIM_PULSE;
	/*ʼPWM*/	
	PWM_OutputInit(PWM0, &OutInit);
	/*ʹͨ1ƥж*/
  PWM_IntConfig(PWM0, PWM_INT_MR0, ENABLE);
	/*ʹPWM*/	
	PWM_Cmd(PWM0, ENABLE);
}
/**
  * @brief  ʼPWM
  * @param  None
  * @retval None
  */
static void PWM_Ini(void)
{
  PWM_GPIO_Config();
  PWM_Mode_Config();	
}


/**
  * @brief  ʱ
  * @param  None
  * @retval None
  */
static void Delay(__IO uint32_t nCount)	 //򵥵ʱ
{
	for(; nCount != 0; nCount--);
}

 /**
  * @brief  ڼⰴǷ񱻳ʱ䰴ͬʱҲڰ
  * @param  
  * @retval 1 ʱ䰴  0 ûбʱ䰴
  */
static uint8_t KEY2_LongPress(void)
{			
	/*¼µĴ*/
	uint8_t downCnt =0;
	/*¼ɿĴ*/
	uint8_t upCnt =0;
	/*ѭreturn*/
	while(1)																										
	{	
	  /*ӳһʱټ*/
		Delay(0x000FF);
	  /*⵽°*/
		if(GPIO_ReadInputDataBit (UserKey_GPIO_Port, UserKey_Pin) == RESET)
		{
	    /*¼´*/
			downCnt++;																					
	    /*ͷż¼*/
			upCnt=0;																						
	    /*ʱ㹻*/
			if(downCnt>=10)																		
			{
	      /*⵽ʱ䳤*/
				return 1; 																				
			}
		}
		else 
		{
	    /*¼ͷŴ*/
			upCnt++; 																						
	    /*⵽ͷų5*/
			if(upCnt>5)																					
			{
	      /*ʱ̫̣ǰ*/
				return 0;																				
			}
		}
	}
}
/**
  * @brief  Main program.
  * @param  None
  * @retval None
  */
int main(void)
{

  /*!< At this stage the microcontroller clock setting is already configured, 
       this is done through SystemInit() function which is called from startup
       file (startup_pt32f0xx.s) before to branch to application main.
       To reconfigure the default setting of SystemInit() function, refer to
       system_pt32x031.c file
     */ 
      
  /* Add your application code here
     */
	/* */
  /*ʼ*/
	UART_Config();
//  /* ʼRGBʵ */
//  LED_GPIO_Config();	
	/*ܽųʼ*/
	UserKey_GPIO_Config();
	/*PWMͨʼ*/
  PWM_Ini();
  /* Infinite loop */
  while (1)
  {
  }
}

#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  printf("Wrong parameters value: file %s on line %d\r\n", file, line);
  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/**
  * @}
  */


/************************ (C) COPYRIGHT PENGPAI Microelectronics *****END OF FILE****/
