/**
  ******************************************************************************
  * @file    Project/PT32x031_StdPeriph_Templates/main.c 
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2020/04/28
  * @brief   Main 
  ******************************************************************************
  * @attention
  *
  * 
  *
  * 
  * 
  * 
  *
  * 
  *
  * 
  * 
  * 
  * 
  * 
  *
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "main.h"

/** @addtogroup PT32x031_StdPeriph_Templates
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/

/**
  * @brief  ADCת10ΣȥֵСֵȡƽֵ     
  * @retval None
  */
uint16_t ADC_SWGetValue(void)
{
  uint8_t i;
  uint16_t PA_int_ADC_Data[10],PV_int_max,PV_int_min;
  uint32_t PV_long_temp=0;

  //ADCת                                       
  for(i=0;i<10;i++)
  {                                     
	/*ADC蹦*/
  ADC_Cmd(ADC, ENABLE);
	/*ȴADC*/
  while(!ADC_GetFlagStatus(ADC,ADC_FLAG_ADRDY));	
	/*ADCת*/
	ADC_StartOfConversion(ADC);
	/*ȴADCһת*/
	while(!ADC_GetFlagStatus(ADC,ADC_FLAG_EOC));
	/*תɱʶλ*/	
	ADC_ClearFlag(ADC,ADC_FLAG_EOC);
	/*ȡADCת*/
	PA_int_ADC_Data[i]=ADC_GetConversionValue(ADC);
	/*رADC蹦*/
  ADC_Cmd(ADC, DISABLE);	
	PV_long_temp+=PA_int_ADC_Data[i];
  }                                          
	/*жСֵ*/
  PV_int_max=PA_int_ADC_Data[0];
  PV_int_min=PA_int_ADC_Data[0];
  for(i=0;i<10;i++)                          
  { 
	if(PA_int_ADC_Data[i]>PV_int_max)
	  PV_int_max=PA_int_ADC_Data[i]; 
	if(PA_int_ADC_Data[i]<PV_int_min)
	  PV_int_min=PA_int_ADC_Data[i];
  }                                             

  //ת
  return((PV_long_temp-PV_int_max-PV_int_min)/8);
}
/**
  * @brief  Main program.
  * @param  None
  * @retval None
  */
  uint16_t adc_result=0x00;
int main(void)
{

  /*!< At this stage the microcontroller clock setting is already configured, 
       this is done through SystemInit() function which is called from startup
       file (startup_pt32f0xx.s) before to branch to application main.
       To reconfigure the default setting of SystemInit() function, refer to
       system_pt32f0xx.c file
     */ 
      
  /* Add your application code here
     */
	/* */
	ADC_InitTypeDef  ADC_InitStruct;
	LED_InitTypeDef  LED_InitStruct;
	/*PB3ΪADCͨ*/
  GPIO_AnalogFunctionConfig(CMSDK_PB, GPIO_Pin_3, ENABLE);
	
	/*ܸͨ*/	
  GPIO_PinAFConfig(CMSDK_PF, GPIO_PinSource0, GPIO_AF_2);
  GPIO_PinAFConfig(CMSDK_PF, GPIO_PinSource1, GPIO_AF_2);	
  GPIO_PinAFConfig(CMSDK_PA, GPIO_PinSource0, GPIO_AF_2);	
  GPIO_PinAFConfig(CMSDK_PA, GPIO_PinSource1, GPIO_AF_2);	
  GPIO_PinAFConfig(CMSDK_PA, GPIO_PinSource2, GPIO_AF_2);	
  GPIO_PinAFConfig(CMSDK_PA, GPIO_PinSource3, GPIO_AF_2);	
  GPIO_PinAFConfig(CMSDK_PA, GPIO_PinSource4, GPIO_AF_2);	
  GPIO_PinAFConfig(CMSDK_PA, GPIO_PinSource5, GPIO_AF_2);	
  GPIO_PinAFConfig(CMSDK_PA, GPIO_PinSource6, GPIO_AF_2);	
  GPIO_PinAFConfig(CMSDK_PA, GPIO_PinSource9, GPIO_AF_2);	
	GPIO_PinAFConfig(CMSDK_PA, GPIO_PinSource10, GPIO_AF_2);	
  GPIO_PinAFConfig(CMSDK_PB, GPIO_PinSource1, GPIO_AF_2);	
	GPIO_PinAFConfig(CMSDK_PB, GPIO_PinSource2, GPIO_AF_2);	
	
	/*ADCĳʼ(תʱ)*/
	ADC_InitStruct.ADC_ContinuousConvMode = DISABLE;
	ADC_InitStruct.ADC_DataAlign = ADC_DataAlign_Right;
	ADC_InitStruct.ADC_ExternalTrigConv = ADC_ExternalTrigConv_Software;
	ADC_InitStruct.ADC_HighSpeedSampMode = DISABLE;

	ADC_Init(ADC, &ADC_InitStruct);
	/*ADCĹʱΪϵͳʱӵİ˷Ƶ*/
	ADC_ClockModeConfig(ADC, ADC_ClockMode_SynClkDiv8);
	/*ADCתͨ*/
	ADC_ChannelConfig(ADC, ADC_Channel_12);
	/*ʼ*/	
	LED_StructInit(&LED_InitStruct);
  LED_Init(&LED_InitStruct);
	/*COMܽλHIGH SINK*/
  LED_HighSinkConfig(LED_COM0|LED_COM1|LED_COM2|LED_COM3, ENABLE);
	/*ʾ*/
  LED_Cmd(ENABLE);
	/*ʾֵʼ ȫʾΪ0*/
	LED_UpdataDisplay(LED_COM0, 0x00);
	LED_UpdataDisplay(LED_COM1, 0x00);
	LED_UpdataDisplay(LED_COM2, 0x00);
	LED_UpdataDisplay(LED_COM3, 0x00);
  /*ADC蹦*/
  ADC_Cmd(ADC, ENABLE);
	/*ȴADC*/
  while(!ADC_GetFlagStatus(ADC,ADC_FLAG_ADRDY));		
  /* Infinite loop */
  while (1)
  {
	/*ѭʾADCɵ*/
	adc_result = 	ADC_SWGetValue();
	LED_UpdataDisplay(LED_COM3,  adc_result%10);
	LED_UpdataDisplay(LED_COM2, (adc_result/10)%10);
	LED_UpdataDisplay(LED_COM1, (adc_result/100)%10);
	LED_UpdataDisplay(LED_COM0, (adc_result/1000)%10);
  }
}


#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/**
  * @}
  */


/************************ (C) COPYRIGHT PENGPAI Microelectronics *****END OF FILE****/
