/**
  ******************************************************************************
  * @file    Project/PT32x031_StdPeriph_Templates/main.h 
  * @author  ӦÿŶ
  * @version 
  * @date    
  * @brief   
  ******************************************************************************
  * @attention
  *
  * 
  *
  * 
  * 
  * 
  *
  *        
  *
  * 
  * 
  * 
  * 
  * 
  *
  ******************************************************************************
  */
  
/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __MAIN_H
#define __MAIN_H

/* Includes ------------------------------------------------------------------*/
#include "pt32x031.h"

#define UserKey_GPIO_Port                CMSDK_PA
#define UserKey_Pin                      GPIO_Pin_11

#define PWM0_CH1_GPIO_Port               CMSDK_PB
#define PWM0_CH1_PinSource               GPIO_PinSource4
#define PWM0_CH1_Pin                     GPIO_Pin_4

#define PWM0_CH2_GPIO_Port               CMSDK_PB
#define PWM0_CH2_PinSource               GPIO_PinSource5
#define PWM0_CH2_Pin                     GPIO_Pin_5

#define LED_CH3_GPIO_Port               CMSDK_PA
#define LED_CH3_PinSource               GPIO_PinSource8
#define LED_CH3_Pin                     GPIO_Pin_8



/* ֱӲĴķIO */
#define	digitalHi(p,i)		 {p->DATAOUT |=i;}	 //Ϊߵƽ		
#define digitalLo(p,i)		 {p->DATAOUT &=~i;}	 //͵ƽ
#define digitalToggle(p,i) {p->DATAOUT ^=i;} //ת״̬

#define LED_CH3_TOGGLE			digitalToggle(LED_CH3_GPIO_Port,LED_CH3_Pin)
#define LED_CH3_OFF					digitalHi(LED_CH3_GPIO_Port,LED_CH3_Pin)
#define LED_CH3_ON					digitalLo(LED_CH3_GPIO_Port,LED_CH3_Pin)

/* Exported types ------------------------------------------------------------*/
/*PWM źŵƵ F = TIM_CLK/{(MR0+1)*(PSC+1)}*/
/*ĬõPWMΪ1M,ռձΪ50%,ʱ2*/
//PWMģʱԤƵ
#define            ADVANCE_TIM_PSC               (3-1)
//PWMģʱ䳣
#define            ADVANCE_TIM_DeadTime           2
//PWMʱ䶨 -- MR0 ֵ
#define            ADVANCE_TIM_PERIOD            (750-1)
//PWM-ch1 ռձȳʼֵ -- MR1
#define            PWM_CH1_DUTY_CYCLE            ((ADVANCE_TIM_PERIOD * 1 / 4)-1)
//PWM-ch2 ռձȳʼֵ -- MR2
#define            PWM_CH2_DUTY_CYCLE            ((ADVANCE_TIM_PERIOD * 2 / 4)-1)
//PWM-ch3 ռձȳʼֵ -- MR3
#define            PWM_CH3_DUTY_CYCLE            ((ADVANCE_TIM_PERIOD * 3 / 4)-1)

/* Exported constants --------------------------------------------------------*/
/* Exported macro ------------------------------------------------------------*/
/* Exported functions ------------------------------------------------------- */

#endif /* __MAIN_H */

/************************ (C) COPYRIGHT PENGPAI Microelectronics *****END OF FILE****/
