/**
  ******************************************************************************
  * @file    Project/PT32x031_StdPeriph_Templates/main.h 
  * @author  ӦÿŶ
  * @version 
  * @date    
  * @brief   
  ******************************************************************************
  * @attention
  *
  * 
  *
  * 
  * 
  * 
  *
  *        
  *
  * 
  * 
  * 
  * 
  * 
  *
  ******************************************************************************
  */
  
/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __MAIN_H
#define __MAIN_H

/* Includes ------------------------------------------------------------------*/
#include "pt32x031.h"


/* Exported types ------------------------------------------------------------*/
typedef enum 
{
	FAILED = 0, 
  PASSED = !FAILED
} TestStatus;
/* Exported constants --------------------------------------------------------*/
/* Exported macro ------------------------------------------------------------*/
/* LEDӵGPIO˿, ûֻҪ޸Ĵ뼴ɸıƵLED */
// R-ɫ
#define LED1_GPIO_PORT    	CMSDK_PB			          /* GPIO˿ */
#define LED1_GPIO_PIN		    GPIO_Pin_4			        /* ӵɫLEDƵGPIO */

// G-ɫ
#define LED2_GPIO_PORT    	CMSDK_PB			          /* GPIO˿ */
#define LED2_GPIO_PIN		    GPIO_Pin_5			        /* ӵɫLEDƵGPIO */

// B-ɫ
#define LED3_GPIO_PORT    	CMSDK_PA			          /* GPIO˿ */
#define LED3_GPIO_PIN		    GPIO_Pin_8			        /* ӵɫLEDƵGPIO */
/** LEDĿ
  * 1 - off
  *0 - on
  */
#define ON  0
#define OFF 1
/*ʹñ׼Ĺ̼LEDƵIO*/
#define LED1(a)	if (a)	\
					GPIO_SetBits(LED1_GPIO_PORT,LED1_GPIO_PIN);\
					else		\
					GPIO_ResetBits(LED1_GPIO_PORT,LED1_GPIO_PIN)

#define LED2(a)	if (a)	\
					GPIO_SetBits(LED2_GPIO_PORT,LED2_GPIO_PIN);\
					else		\
					GPIO_ResetBits(LED2_GPIO_PORT,LED2_GPIO_PIN)

#define LED3(a)	if (a)	\
					GPIO_SetBits(LED3_GPIO_PORT,LED3_GPIO_PIN);\
					else		\
					GPIO_ResetBits(LED3_GPIO_PORT,LED3_GPIO_PIN)
					
/* ֱӲĴķIO */
#define	digitalHi(p,i)		 {p->DATAOUT |=i;}	 //Ϊߵƽ		
#define digitalLo(p,i)		 {p->DATAOUT &=~i;}	 //͵ƽ
#define digitalToggle(p,i) {p->DATAOUT ^=i;} //ת״̬


/* IOĺ */
#define LED1_TOGGLE		 digitalToggle(LED1_GPIO_PORT,LED1_GPIO_PIN)
#define LED1_OFF		   digitalHi(LED1_GPIO_PORT,LED1_GPIO_PIN)
#define LED1_ON			   digitalLo(LED1_GPIO_PORT,LED1_GPIO_PIN)

#define LED2_TOGGLE		 digitalToggle(LED2_GPIO_PORT,LED2_GPIO_PIN)
#define LED2_OFF		   digitalHi(LED2_GPIO_PORT,LED2_GPIO_PIN)
#define LED2_ON			   digitalLo(LED2_GPIO_PORT,LED2_GPIO_PIN)

#define LED3_TOGGLE		 digitalToggle(LED3_GPIO_PORT,LED3_GPIO_PIN)
#define LED3_OFF		   digitalHi(LED3_GPIO_PORT,LED3_GPIO_PIN)
#define LED3_ON			   digitalLo(LED3_GPIO_PORT,LED3_GPIO_PIN)

//
#define LED_RED  \
					LED1_ON;\
					LED2_OFF\
					LED3_OFF

//
#define LED_GREEN		\
					LED1_OFF;\
					LED2_ON\
					LED3_OFF

//
#define LED_BLUE	\
					LED1_OFF;\
					LED2_OFF\
					LED3_ON

					
//(+)					
#define LED_YELLOW	\
					LED1_ON;\
					LED2_ON\
					LED3_OFF
//(+)
#define LED_PURPLE	\
					LED1_ON;\
					LED2_OFF\
					LED3_ON

//(+)
#define LED_CYAN \
					LED1_OFF;\
					LED2_ON\
					LED3_ON
					
//(++)
#define LED_WHITE	\
					LED1_ON;\
					LED2_ON\
					LED3_ON
					
//(ȫر)
#define LED_RGBOFF	\
					LED1_OFF;\
					LED2_OFF\
					LED3_OFF
					
/* Exported functions ------------------------------------------------------- */

#endif /* __MAIN_H */

/************************ (C) COPYRIGHT PENGPAI Microelectronics *****END OF FILE****/
